<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSpecialRemarkTypeAuthorizedViewer ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfSpecialRemarkTypeAuthorizedViewer extends AbstractStructArrayBase
{
    /**
     * The AuthorizedViewer
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgAuthorizedViewer[]
     */
    public $AuthorizedViewer;
    /**
     * Constructor method for ArrayOfSpecialRemarkTypeAuthorizedViewer
     * @uses DgArrayOfSpecialRemarkTypeAuthorizedViewer::setAuthorizedViewer()
     * @param \dgsoft\StructType\DgAuthorizedViewer[] $authorizedViewer
     */
    public function __construct(array $authorizedViewer = array())
    {
        $this
            ->setAuthorizedViewer($authorizedViewer);
    }
    /**
     * Get AuthorizedViewer value
     * @return \dgsoft\StructType\DgAuthorizedViewer[]|null
     */
    public function getAuthorizedViewer()
    {
        return $this->AuthorizedViewer;
    }
    /**
     * Set AuthorizedViewer value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgAuthorizedViewer[] $authorizedViewer
     * @return \dgsoft\ArrayType\DgArrayOfSpecialRemarkTypeAuthorizedViewer
     */
    public function setAuthorizedViewer(array $authorizedViewer = array())
    {
        foreach ($authorizedViewer as $arrayOfSpecialRemarkTypeAuthorizedViewerAuthorizedViewerItem) {
            // validation for constraint: itemType
            if (!$arrayOfSpecialRemarkTypeAuthorizedViewerAuthorizedViewerItem instanceof \dgsoft\StructType\DgAuthorizedViewer) {
                throw new \InvalidArgumentException(sprintf('The AuthorizedViewer property can only contain items of \dgsoft\StructType\DgAuthorizedViewer, "%s" given', is_object($arrayOfSpecialRemarkTypeAuthorizedViewerAuthorizedViewerItem) ? get_class($arrayOfSpecialRemarkTypeAuthorizedViewerAuthorizedViewerItem) : gettype($arrayOfSpecialRemarkTypeAuthorizedViewerAuthorizedViewerItem)), __LINE__);
            }
        }
        $this->AuthorizedViewer = $authorizedViewer;
        return $this;
    }
    /**
     * Add item to AuthorizedViewer value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgAuthorizedViewer $item
     * @return \dgsoft\ArrayType\DgArrayOfSpecialRemarkTypeAuthorizedViewer
     */
    public function addToAuthorizedViewer(\dgsoft\StructType\DgAuthorizedViewer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgAuthorizedViewer) {
            throw new \InvalidArgumentException(sprintf('The AuthorizedViewer property can only contain items of \dgsoft\StructType\DgAuthorizedViewer, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AuthorizedViewer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgAuthorizedViewer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgAuthorizedViewer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgAuthorizedViewer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgAuthorizedViewer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgAuthorizedViewer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AuthorizedViewer
     */
    public function getAttributeName()
    {
        return 'AuthorizedViewer';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfSpecialRemarkTypeAuthorizedViewer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
